import os
from PyQt4 import QtCore, QtGui
from configobj import ConfigObj
from os.path import dirname,isfile
import time

class rosterStyle:
	def __init__(self,roster,config):
		self.roster=roster
		self.configPath=unicode(config)
		self.config=ConfigObj(config,encoding='UTF8')
		self.defaultColor=QtGui.QColor(self.roster.palette().color(QtGui.QPalette.Window))
		self.defaultBrush=QtGui.QBrush(self.roster.palette().brush(QtGui.QPalette.Window))
		self.reloadResources()

	def reloadResources(self):
		self.images={}
		self.colors={}
		tmp=dirname(self.configPath).split("/")[-1]
		if self.config.has_key("images"):
			for name,src in self.config['images'].iteritems():
				if isfile(dirname(self.configPath)+"/"+src):
					self.images[name]=QtGui.QPixmap(dirname(self.configPath)+"/"+src)
				elif isfile("rosterstyles/"+tmp+"/"+src):
					self.images[name]=QtGui.QPixmap("rosterstyles/"+tmp+"/"+src)
				else:
					self.images[name]=QtGui.QPixmap("rosterstyles/ng/"+src)
				
		if self.config.has_key("colors"):
			for name,rgb in self.config['colors'].iteritems():
				if len(rgb)==4:
					self.colors[name]=QtGui.QColor(int(rgb[0]),int(rgb[1]),int(rgb[2]),int(rgb[3]))
				else:
					self.colors[name]=QtGui.QColor(int(rgb[0]),int(rgb[1]),int(rgb[2]))
		if self.config['groupitem']['shape']=='rounded':
			self.generateRoundedStyle()
		if not self.images.has_key("rosterBackground"):
			if self.colors.has_key("rosterBackground"):
				self.roster.palette().setColor(QtGui.QPalette.Window,self.colors['rosterBackground'])
			else:
				self.roster.palette().setColor(QtGui.QPalette.Window,self.defaultColor)
		if not self.colors.has_key("rosterBackground"):
			if self.images.has_key("rosterBackground"):
				b=QtGui.QBrush()
				b.setTexture(self.images['rosterBackground'])
				self.roster.palette().setBrush(QtGui.QPalette.Window,b)
			else:
				self.roster.palette().setBrush(QtGui.QPalette.Window,self.defaultBrush)
		if self.config['groupitem']['shape']=='rounded':
			self.generateRoundedStyle()
		self.spaceBetweenGroups=int(self.config['groupitem']['spaceBetweenGruops'])
		

	def resizeEvent(self):
#		b=QtGui.QBrush()
#		b.setTexture(QtGui.QPixmap("pozadi_okrove_srafovane.png"))
#		self.roster.palette().setBrush(QtGui.QPalette.Window,b)
		if self.config['groupitem']['shape']=='rounded':
			self.generateRoundedStyle()
		if not self.images.has_key("rosterBackground"):
			if self.colors.has_key("rosterBackground"):
				self.roster.palette().setColor(QtGui.QPalette.Window,self.colors['rosterBackground'])
			else:
				self.roster.palette().setColor(QtGui.QPalette.Window,self.defaultColor)
		if not self.colors.has_key("rosterBackground"):
			if self.images.has_key("rosterBackground"):
				b=QtGui.QBrush()
				b.setTexture(self.images['rosterBackground'])
				self.roster.palette().setBrush(QtGui.QPalette.Window,b)
			else:
				self.roster.palette().setBrush(QtGui.QPalette.Window,self.defaultBrush)

	def generateRoundedStyle(self):
		#self.shadow1=QtGui.QPixmap("rosterstyles/ng/stin_vertikalni_levy.png")
		self.roundedGroup=QtGui.QPixmap(self.roster.width(),int(self.config['groupitem']['height']))
		self.roundedGroup.fill(QtCore.Qt.transparent)
		p=QtGui.QPainter(self.roundedGroup)

		r=QtGui.QPixmap("rosterstyles/ng/uzavreny_pravy_stin.png")
		l=QtGui.QPixmap("rosterstyles/ng/uzavreny_levy_stin.png")
		s=QtGui.QPixmap("rosterstyles/ng/uzavreny_stred_stin.png")
		p.drawPixmap(3,0,l)
		for x in range(3+l.width(),self.roundedGroup.width()-3-r.width()):
			p.drawPixmap(x,0,s)
		p.drawPixmap(self.roundedGroup.width()-3-r.width(),0,r)
		
		r=QtGui.QPixmap("rosterstyles/ng/uzavreny_pravy_plna_barva.png")
		p.drawRoundedRect 
		l=QtGui.QPixmap("rosterstyles/ng/uzavreny_levy_plna_barva.png")

		p.setBrush(QtGui.QBrush(self.colors[(self.config['groupitem']['backgroundColor'][4])]))
		p.setPen(QtGui.QPen(self.colors[(self.config['groupitem']['backgroundColor'][4])]))
		p.setRenderHint(p.Antialiasing,True)
		p.drawRoundedRect(6,3,self.roundedGroup.width()-12,22,10,10)
		p.setRenderHint(p.Antialiasing,False)

		r=QtGui.QPixmap("rosterstyles/ng/uzavreny_pravy_alfa.png")
		l=QtGui.QPixmap("rosterstyles/ng/uzavreny_levy_alfa.png")
		s=QtGui.QPixmap("rosterstyles/ng/uzavreny_stred_alfa.png")
		p.drawPixmap(3,0,l)
		for x in range(3+l.width(),self.roundedGroup.width()-3-r.width()):
			p.drawPixmap(x,0,s)
		p.drawPixmap(self.roundedGroup.width()-3-r.width(),0,r)


		
		
		self.roundedGroupExpanded=QtGui.QPixmap(self.roster.width(),int(self.config['groupitem']['height']))
		self.roundedGroupExpanded.fill(QtCore.Qt.transparent)
		p=QtGui.QPainter(self.roundedGroupExpanded)

		r=QtGui.QPixmap("rosterstyles/ng/otevreny_pravy_stin.png")
		l=QtGui.QPixmap("rosterstyles/ng/otevreny_levy_stin.png")
		s=QtGui.QPixmap("rosterstyles/ng/otevreny_stred_stin.png")
		p.drawPixmap(3,0,l)
		for x in range(3+l.width(),self.roundedGroupExpanded.width()-3-r.width()):
			p.drawPixmap(x,0,s)
		p.drawPixmap(self.roundedGroupExpanded.width()-3-r.width(),0,r)
		
		r=QtGui.QPixmap("rosterstyles/ng/otevreny_pravy_plna_barva.png")
		p.drawRoundedRect 
		l=QtGui.QPixmap("rosterstyles/ng/otevreny_levy_plna_barva.png")

		p.setBrush(QtGui.QBrush(self.colors[(self.config['groupitem']['backgroundColor'][4])]))
		p.setPen(QtGui.QPen(self.colors[(self.config['groupitem']['backgroundColor'][4])]))
		p.setRenderHint(p.Antialiasing,True)
		p.drawRoundedRect(6,3,self.roundedGroupExpanded.width()-12,50,10,10)
		p.setRenderHint(p.Antialiasing,False)

		r=QtGui.QPixmap("rosterstyles/ng/otevreny_pravy_alfa.png")
		l=QtGui.QPixmap("rosterstyles/ng/otevreny_levy_alfa.png")
		s=QtGui.QPixmap("rosterstyles/ng/otevreny_stred_alfa.png")
		p.drawPixmap(3,0,l)
		for x in range(3+l.width(),self.roundedGroupExpanded.width()-3-r.width()):
			p.drawPixmap(x,0,s)
		p.drawPixmap(self.roundedGroupExpanded.width()-3-r.width(),0,r)

		
		self.roundedEnd=QtGui.QPixmap(self.roster.width(),29)
		self.roundedEnd.fill(QtCore.Qt.transparent)
		p=QtGui.QPainter(self.roundedEnd)
		p.setBrush(QtGui.QBrush(self.colors[(self.config['useritem']['backgroundColor'][4])]))
		p.setPen(QtGui.QPen(self.colors[(self.config['useritem']['backgroundColor'][4])]))
		p.setRenderHint(p.Antialiasing,True)
		p.drawRoundedRect(6,-22,self.roundedGroup.width()-12,29,10,10)
		p.setRenderHint(p.Antialiasing,False)

		self.roundedStart=QtGui.QPixmap(self.roster.width(),12)
		self.roundedStart.fill(QtCore.Qt.transparent)
		p=QtGui.QPainter(self.roundedStart)
		p.setBrush(QtGui.QBrush(self.colors[(self.config['useritem']['backgroundColor'][4])]))
		p.setPen(QtGui.QPen(self.colors[(self.config['useritem']['backgroundColor'][4])]))
		p.setRenderHint(p.Antialiasing,True)
		p.drawRoundedRect(6,3,self.roundedGroupExpanded.width()-12,50,10,10)
		p.setRenderHint(p.Antialiasing,False)
		
	def heightForItem(self,item):
		# normal userItem
		if item.typ=="user":
			if self.config['useritem']['height']!="auto":
				ret=int(self.config['useritem']['height'])
				if item.statusMessage and len(item.statusMessage)>0:
					ret+=int(self.config['useritem']['statusHeight'])
				return ret
			ret=35
			if item.statusMessage and len(item.statusMessage)>0:
				font=QtGui.QTextDocument().defaultFont()
				font.setPixelSize(10)
				metrics=QtGui.QFontMetrics(font)
				rect=metrics.boundingRect(0, 0,self.roster.width()-7, 100, QtCore.Qt.TextWordWrap, item.statusMessage)
				height=rect.height()
				if height>32:
					text=""
					for word in item.statusMessage.split(' '):
						rect=metrics.boundingRect(0, 0,self.roster.width()-7, 100, QtCore.Qt.TextWordWrap, text+"...")
						h=rect.height()
						if h>32:
							item.statusMessage=text+"..."
							ret+=32
							break
						height=h
						text+=word+" "
				else:
					ret+=height

			if item.tune:
				ret+=20
			return ret
		# groupItem
		elif item.typ=="group" and item.main!="special":
			return int(self.config['groupitem']['height'])+self.spaceBetweenGroups
		# specialItem => used for blank space between users in group and users without group
		else:
			return 32

	def paintSelectedUserItem(self,painter,useritem,x,y,last):
		self.paintItem(painter,useritem,x,y,'selected useritem',last)

	
	def paintUnselectedUserItem(self,painter,useritem,x,y,last):
		self.paintItem(painter,useritem,x,y,'useritem',last)

	def paintItem(self,painter,useritem,x,y,typ,last):
		t=time.time()
		if self.config[typ].has_key('backgroundColor'):
			painter.fillRect(x+int(self.config[typ]['backgroundColor'][0]),y+int(self.config[typ]['backgroundColor'][1]),self.roster.width()-x-int(self.config[typ]['backgroundColor'][0])+int(self.config[typ]['backgroundColor'][2]),useritem.height+int(self.config[typ]['backgroundColor'][3]),QtGui.QBrush(self.colors[(self.config[typ]['backgroundColor'][4])]))
			#if self.config['groupitem']['shape']=="rounded":
			#	for i in range(0,useritem.height):
			#		painter.drawPixmap(x+int(self.config[typ]['backgroundColor'][0])-3,y+i,self.shadow1)
		if self.config['groupitem']['shape']=='rounded' and last:
			painter.drawPixmap(0,y+useritem.height,self.roundedEnd)
		doc=QtGui.QTextDocument()
		font=doc.defaultFont()
		font.setPixelSize(int(self.config[typ]['fontSize']))
		doc.setDefaultFont(font)
		metrics=QtGui.QFontMetrics(font)
		text=self.config[typ]['textFormat'].replace("%text%",useritem.escapedName).replace("%fontColor%",self.colors[self.config[typ]['fontColor']].name())
		textWidth=metrics.width(useritem.escapedName)
		painter.save()
		if int(self.config[typ]['textCoordinates'][0])<0:
			painter.translate(x+self.roster.width()+int(self.config[typ]['textCoordinates'][0])-textWidth,y+int(self.config[typ]['textCoordinates'][1]))
		else:
			painter.translate(x+int(self.config[typ]['textCoordinates'][0]),y+int(self.config[typ]['textCoordinates'][1]))
		doc.setHtml(text)
		doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width()-int(self.config[typ]['textCoordinates'][0])-int(self.config[typ]['textCoordinates'][2]),int(self.config[typ]['textCoordinates'][3])))
		painter.restore()
		
		if useritem.statusMessage and self.config[typ].has_key("statusTextCoordinates"):
			painter.save()
			painter.translate(x+int(self.config[typ]['statusTextCoordinates'][0]),y+int(self.config[typ]['statusTextCoordinates'][1]))
			font=doc.defaultFont()
			font.setPixelSize(int(self.config[typ]['statusFontSize']))
			doc.setDefaultFont(font)
			metrics=QtGui.QFontMetrics(font)
			doc.setHtml(self.config[typ]['statusTextFormat'].replace("%text%",useritem.statusMessage).replace("%fontColor%",self.colors[self.config[typ]['statusFontColor']].name()))
			#doc.setPageSize(QtCore.QSizeF(self.roster.width()-7,32))
			doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width()-int(self.config[typ]['statusTextCoordinates'][0])-int(self.config[typ]['statusTextCoordinates'][2]),int(self.config[typ]['statusTextCoordinates'][3])))
			painter.restore()

		if self.config[typ].has_key("avatarCoordinates"):
			avatar=self.roster.main.client.getAvatarImg(useritem.jid)
			if avatar:
				avatar=avatar[0]
			else:
				avatar=self.roster.main.client.getAvatarImg(None)
				if avatar:
					avatar=avatar[0]
			if avatar.width()!=int(self.config[typ]['avatarSize'][0]):
				avatar=avatar.scaled(int(self.config[typ]['avatarSize'][0]),int(self.config[typ]['avatarSize'][1]),QtCore.Qt.KeepAspectRatio,QtCore.Qt.SmoothTransformation)
			if int(self.config[typ]['avatarCoordinates'][0])<0:
				painter.drawPixmap(self.roster.width()+int(self.config[typ]['avatarCoordinates'][0])-int(self.config[typ]['avatarSize'][0]),y+int(self.config[typ]['avatarCoordinates'][1]),avatar)
			else:
				painter.drawPixmap(int(self.config[typ]['avatarCoordinates'][0]),y+int(self.config[typ]['avatarCoordinates'][1]),avatar)
		if int(self.config[typ]['iconCoordinates'][0])<0:
			painter.drawPixmap(self.roster.width()+int(self.config[typ]['iconCoordinates'][0])-int(self.config[typ]['iconSize'][0]),y+int(self.config[typ]['iconCoordinates'][1]),useritem.icon.pixmap(int(self.config[typ]['iconSize'][0]),int(self.config[typ]['iconSize'][1])))
		else:
			painter.drawPixmap(int(self.config[typ]['iconCoordinates'][0]),y+int(self.config[typ]['iconCoordinates'][1]),useritem.icon.pixmap(int(self.config[typ]['iconSize'][0]),int(self.config[typ]['iconSize'][1])))

		print "creating avatar lasts",time.time()-t
		return
		avatar=self.roster.main.client.getAvatarImg(useritem.jid)
		if avatar:
			avatar=avatar[0]
		else:
			avatar=self.roster.main.client.getAvatarImg(None)
			if avatar:
				avatar=avatar[0]
		painter.drawPixmap(x+7,y,avatar)
		if useritem.privacy['block'] or useritem.privacy['hide']:
			painter.drawPixmap(self.roster.width()-32,y,self.roster.main.getIcon(status="error",size="32x32").pixmap(16,16))
		else:
			painter.drawPixmap(self.roster.width()-32,y,useritem.icon.pixmap(32,32))
		doc=QtGui.QTextDocument()
		font=QtGui.QApplication.fontMetrics()
		fontHeight=int(font.height())
		font=doc.defaultFont()
		painter.save()
		painter.translate(x+40,y+4)
		font.setPixelSize(16)
		doc.setDefaultFont(font)
		doc.setHtml("<font color=\"#000000\"><b>"+useritem.escapedName+"</b></font>")
		doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width()-70,y+23))
		painter.restore()
		font.setPixelSize(10)
		doc.setDefaultFont(font)
		diff=0
		if useritem.tune:
			painter.drawPixmap(7,y+32,useritem.tune)
			painter.save()
			painter.translate(x+7+17,y+32)
			doc.setHtml("<font color=\"#000000\">"+useritem.song+"</font>")
			doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width(),32))
			painter.restore()
			diff+=20

		opt=doc.defaultTextOption()
		opt.setWrapMode(QtGui.QTextOption.WrapAtWordBoundaryOrAnywhere)
		doc.setDefaultTextOption(opt)
		if useritem.statusMessage:
			painter.save()
			painter.translate(x+7,y+32+diff)

			doc.setHtml("<font color=\"#000000\">"+useritem.statusMessage+"</font>")
			doc.setPageSize(QtCore.QSizeF(self.roster.width()-7,32))
			doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width()-7,32))
			painter.restore()

	def paintGroupItem(self,painter,item,x,y):
		"""
		paints group item in normal roster
		"""
		y=int(y)+self.spaceBetweenGroups
		if item.main=="special":
			if self.config['groupitem']['shape']=='rounded':
				painter.drawPixmap(x,y+10,self.roundedStart)
				#painter.drawPixmap(0,y-self.spaceBetweenGroups,self.roundedEnd)
			return
		#painter.drawPixmap(x,y,self.groupBg)
		if self.config['groupitem']['shape']=='rounded':
			if item.expanded:
				painter.drawPixmap(x,y,self.roundedGroupExpanded)
			else:
				painter.drawPixmap(x,y,self.roundedGroup)
		else:
			if self.config['groupitem'].has_key('backgroundColor'):
				painter.fillRect(x+int(self.config['groupitem']['backgroundColor'][0]),y+int(self.config['groupitem']['backgroundColor'][1]),self.roster.width()-x-int(self.config['groupitem']['backgroundColor'][0])+int(self.config['groupitem']['backgroundColor'][2]),int(self.config['groupitem']['backgroundColor'][3]),QtGui.QBrush(self.colors[(self.config['groupitem']['backgroundColor'][4])]))
			if self.config['groupitem'].has_key('backgroundImage'):
				painter.drawPixmap(x+int(self.config['groupitem']['backgroundImage'][0]),y+int(self.config['groupitem']['backgroundImage'][1]),self.images[self.config['groupitem']['backgroundImage'][2]])
		
		doc=QtGui.QTextDocument()
		font=doc.defaultFont()
		font.setPixelSize(int(self.config['groupitem']['fontSize']))
		doc.setDefaultFont(font)
		metrics=QtGui.QFontMetrics(font)
		text=self.config['groupitem']['textFormat'].replace("%text%",item.escapedName).replace("%fontColor%",self.colors[self.config['groupitem']['fontColor']].name())
		textWidth=metrics.width(item.escapedName)
		painter.save()
		if int(self.config['groupitem']['textCoordinates'][0])<0:
			painter.translate(x+self.roster.width()+int(self.config['groupitem']['textCoordinates'][0])-textWidth,y+int(self.config['groupitem']['textCoordinates'][1]))
		else:
			painter.translate(x+int(self.config['groupitem']['textCoordinates'][0]),y+int(self.config['groupitem']['textCoordinates'][1]))
		doc.setHtml(text)
		doc.drawContents(painter, QtCore.QRectF(0,0,self.roster.width(),y+23))
		painter.restore()
		if item.expanded:
			painter.drawPixmap(x+int(self.config['groupitem']['openedIcon'][0]),y+int(self.config['groupitem']['openedIcon'][1]),self.images[self.config['groupitem']['openedIcon'][2]])
		else:
			painter.drawPixmap(x+int(self.config['groupitem']['closedIcon'][0]),y+int(self.config['groupitem']['closedIcon'][1]),self.images[self.config['groupitem']['closedIcon'][2]])
		return

	def paintUserItem(self,painter,useritem,x,y,last):
		"""
		paints user item in normal roster
		"""
		if useritem==self.roster.item:
			self.paintSelectedUserItem(painter,useritem,x,y,last)
		else:
			self.paintUnselectedUserItem(painter,useritem,x,y,last)
	

